      Program evolve_tmd
      Include 'SMallx.inc'
       Integer Iev 
C---Standard LEP event common block 
      Integer NMXHEP,NEVHEP,NHEP,ISTHEP,IDHEP,JMOHEP,JDAHEP 
      Double Precision PHEP,VHEP,EVWGT 
      PARAMETER (NMXHEP=4000) 
      COMMON/HEPEVTP/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP), 
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP) 
C---Event weight 
C   N.B. weights must be renormalized to momentum sum 
      COMMON/HEPWGT/EVWGT 
      Integer nobran,ikincut
      common/myvar/nobran,ikincut

	Double Precision Qbarmy,Qbar_min,Qbar_max
      Common/mglubran/Qbarmy,Qbar_min,Qbar_max
      Integer neve
	common/myevt/neve
	Integer nloop
	common/myloop/nloop
      Double Precision x3lmin,x3lmax,x3ldif
	Integer Nbp
      Parameter (Nbp=50)
      Double Precision X3(0:Nbp+1)
      Double Precision X3M(0:Nbp)
      Double Precision x3b(0:Nbp)
      common/gridtt/x3m
	Integer ng_max
	Integer nrglu
	Common/mynrglu/nrglu
	Integer nmax,i,nx3,kev,ic
	Integer Ipgg,ns_sel
	Double Precision scal 
	common/Pggsel/Ipgg,ns_sel,scal
	Double Precision Qgmin
      character *72 TXT
      CHARACTER   FILNAME*132,testNAME*132
      Common/gludatf/filname
	Double Precision Xnorm
      common/smnorm/ Xnorm
      Logical pdflib,quark,gluon,photon,saturation
      Common /SMbran2/pdflib,quark,gluon,photon,saturation
      Integer Ioneloop,Itarget,Iglu,Isaturation
      Integer Ipdf
      Common/pdf/Ipdf
      Integer iparton
      Common /SMquark/iparton
      character *15 char
	Double Precision BB
	Common /splitting/ BB
      Double precision ininorm(-6:6)
      common/smininorm/ininorm
     
      Integer IRR
	double precision au 
      Logical first
      common/f2fit/au(50),first
            
      
*
      read(5,*) filname
      write(6,*) ' output file ',filname
      xnorm = 1.
      Read(5,101) TXT
      read(txt,1005) char,Ioneloop
      write(6,*) txt,char,Ioneloop
1005  format(a10,I8)
      Read(5,101) TXT
      read(txt,1010) char,Isaturation
1010  format(a14,I8)
      write(6,*) txt,char,Isaturation
      Read(5,101) TXT
      read(txt,1006) char,Ipdf
      write(6,*) txt,char,Ipdf
1006  format(a7,I8)
      Read(5,101) TXT
      read(txt,1007) char,Itarget
      write(6,*) txt,char,Itarget
1007  format(a10,I8)
      Read(5,101) TXT
      read(txt,1008) char,Iglu
      write(6,*) txt,char,Iglu
1008  format(a7,I8)
      Read(5,101) TXT
  101 Format(A72)
      read(txt,1000) char,Ipgg
      write(6,*) txt,char,Ipgg
1000  format(a7,I8)
      Read(5,101) TXT
      read(txt,1001) char,ns_sel
      write(6,*) txt,char,ns_sel
1001  format(a5,I8)
      Read(5,101) TXT
      read(txt,1011) char,ikincut
      write(6,*) txt,char,ikincut
1011  format(a10,I8)
      Read(5,101) TXT
      read(txt,1002) char,Qg
      write(6,*) txt,char,Qg
1002  format(a5,F16.8)
      Read(5,101) TXT
      read(txt,1003) char,Qs
      write(6,*) txt,char,Qs
1003  format(a5,F16.8)
      Read(5,101) TXT
      read(txt,1018) char,QCDlam
      write(6,*) txt,char,QCDlam
1018  format(a9,F16.8)
      Read(5,101) TXT
      read(txt,1003) char,AU(1)
      Read(5,101) TXT
      read(txt,1003) char,AU(2)
      Read(5,101) TXT
      read(txt,1003) char,AU(3)
      Read(5,101) TXT
      read(txt,1003) char,AU(4)
      Read(5,101) TXT
      read(txt,1003) char,AU(5)
      Read(5,101) TXT
      read(txt,1003) char,AU(6)
      
c      write(6,*) ' qcdlma ',qcdlam,' ikincut ',ikincut
      if(iglu.ne.0) then
          gluon = .true.
          else
          gluon = .false.
        endif 
      If(Ioneloop.eq.1) then
	  onel = .true.
	  else
	  onel=.false.
	Endif
      If(Isaturation.eq.1) then
	  saturation = .true.
	  else
	  saturation=.false.
	Endif
      if(itarget.eq.22) then
	  photon = .true.
	  else
	  photon = .false.
	Endif
      if(iglu.eq.0) then
        Read(50,101) TXT  
        read(txt,1009) char,Iparton
        write(6,*) txt,char,Iparton
        write(6,*) txt
1009    format(a9,I8)
      endif
	close(50)

C---Initialize run 
      Call SMinit 
	neve = 0
	nmax =nev
	Xini = 0.
      write(6,*) ' output file ',filname
      write(6,*) ' selection Ipgg = ',Ipgg,' ns_sel = ',ns_sel
      write(6,*) ' Qg = ',Qg,' Qs = ',Qs,' Xnorm = ',Xnorm
	write(6,*) ' LHAPDFLIB for val quark Ipdf = ',Ipdf
      write(6,*) ' Itarget = ',Itarget
      write(6,*) ' BB = ',BB

         Qgmin = max(Qg-0.5d0,QCDlam)
         Qgmin = max(Qg,QCDlam)
	   x3lmin = log(Qgmin)  
	   x3lmax = log(qmax)
	   x3ldif = (x3lmax-x3lmin)/Real(Nbp)
         Do I=0,Nbp+1
            x3(I) = exp(x3lmin + x3ldif*Real(I))
         Enddo
	   Do I=0,Nbp
	      x3m(i) = (x3(i) + x3(i+1))/2.
		x3b(i) = x3(i+1) - x3(i)
c		write(6,*) ' gluon p_max ',x3m(i),i
         Enddo
	Nx3 = -1
C---Initialize analysis 
      Xini=0.
      Xfin=0.
      Call updfgrid(1)
      


      Nx3 = 49
600   Nx3 = Nx3 + 1
      write(6,*) ' ng_max = ',ng_max,' at nx3-1 ',nx3-1
      IF(Nx3.gt.Nbp) Then
        write(6,*) ' evolve_tmd: Nx3 gt Npb -> Program stopped'
        stop
      Endif
	Qbarmy = x3m(Nx3)
	nloop = Nx3
	ng_max = 0

	write(6,*) ' Qbar_my  ',Qbarmy 
      
      do Iparton=0,2
      write(6,*) ' evolving parton ID: ',Iparton 
        if(iparton.eq.0) then 
           gluon=.true.
           else
           gluon=.false.
        endif
        Xini = 0
        do I=1,nev
C---Initialize event 
          Call SMinfn 

C---Small-x gluon branching process 
          Call smbran 

	    Xini = Xini + x0
	    if(ng_max.le.nrglu) ng_max=nrglu
          

          If(wt.NE.0.0) then
             kev=i 
             if (kev.gt.0) ic=100000 
             if (mod(kev,ic).eq.0) write(6,*) ' event ',kev,nev,' loop P_max ',nloop,Qbarmy
	    endif
c          write(6,*) ' in loop2: Iparton = ',Iparton, I
         End do
      End do

      call updfgrid(3)
      Stop
  80  Write(6,*) ' steering file for evolve_tmd not found '
      stop    
      End 
	 
      Function fl(x)
      real fl,x
      fl=0.
      return
      end
      function fu(x)
      real fu,x
      fu=1. 
      return
      end
	
	
