      Subroutine SMinfn
C--Choose starting conditions for branching

      Include 'SMallx.inc'
      Integer Kid
      Common /SMbran1/Kid(0:1000)

      Integer Ipdf
      Common/pdf/Ipdf
      Logical pdflib,quark,gluon,photon,saturation
      Common /SMbran2/pdflib,quark,gluon,photon,saturation
      Integer iparton
      Common /SMquark/iparton
	Double Precision Xnorm
      common/smnorm/ Xnorm

      Double Precision SMrgen,SMrgau,u,yinf,frat,Qinf,Qsup
      Double Precision Rdq

	Double Precision Scale,test,xgmax,xnormn

      Double Precision  XX,QQ,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU,
     +VAL(20),QQ2,PP2
      Integer Ip2
      CHARACTER*20 PARM(20)
	
	Real slo,shi,xint,eps
	Integer i
	
	Double Precision xtmin,xtmax,dx,xt
	Integer nstep
	Integer nx
	Double Precision dlxmin,dlxmax,deltax,xmi,xma,sum
	Logical first,first1
	Data first/.true./,first1/.true./
	External xint
      Integer IpartonO
      Double Precision qgmin,qgmax,xmymin,WQG2,Wx0,xi,kt2i,ti,Qx2
      Double Precision xpq(-6:6),qg2max
      Double Precision kt,phi_k
      Integer nobran,ikincut
      common/myvar/nobran,ikincut
      integer iktscheme	
	Double precision wt0
      common/myweight/wt0
      Double Precision sigm, xmean
	Double precision alphas,sigm0,lam,x01,r02,xgx0
      
      Logical Kernel
      Data Kernel/.false./
      
	Real A1,A2,A3,A4,A5,A6
	double precision au 
      common/f2fit/au(50),first
      Double precision ininorm(-6:6)
      common/smininorm/ininorm
      
      Double Precision Ncall, sumkt, Wtest
      Double Precision pi
      pi = 4.*atan(1.)
     
     
      iktscheme =1

      Jev=Jev+1
c      Write(6,*) ' sminit ininorm(0) ',ininorm(0),Xnor
      if(nobran.eq.2) then
         qgmin = 0.000001d0
         qgmax = Sbig
         Qx2 = QGMIN*((QGMAX/QGMIN)**SMrgen(1))
         WQG2 = Qx2*LOG(QGMAX/QGMIN)
         xmymin=max(1e-7,xmin)

         x0 = xmymin*(xmax/xmymin)**SMrgen(2)
         Wx0 = x0*log(xmax/xmymin)
c--choose starting Qt
         PHI_K = 2*pi*Smrgen(3)
         P(1,0)= sqrt(qx2)*cos(phi_k)
         P(2,0)= sqrt(qx2)*sin(phi_k)
        Wt=1.
      else

c--choose starting Qt
        if(iktscheme.eq.2) then
          qgmin = 0.0001
          qgmax = Sbig
          qx2 = qgmin*((qgmax/qgmin)**SMrgen(1))
c--choose starting Qt
          PHI_K = 2*pi*Smrgen(3)
          P(1,0)= sqrt(qx2)*cos(phi_k)
          P(2,0)= sqrt(qx2)*sin(phi_k)
c          write(6,*) ' sminfn_gluon ',iktscheme,qx2,P(1,0),P(2,0)
        else 
          qx2 = qx
          sigm = Qx
          xmean = 0.0
          P(1,0)= SMrgau(1,xmean,sigm)
          P(2,0)= SMrgau(2,xmean,sigm)
        endif
	  x0=0.99
        Wt=1.
        if(kernel) then
          x0=0.99
          else
          if(saturation) then
             qgmin = 0.000001d0
             qgmin = 0.00010001d0
             qgmax = Sbig
             qgmax = 100.
             Qx2 = QGMIN*((QGMAX/QGMIN)**SMrgen(1))
             WQG2 = Qx2*LOG(QGMAX/QGMIN)
c--choose starting Qt
             PHI_K = 2*pi*Smrgen(3)
             P(1,0)= sqrt(qx2)*cos(phi_k)
             P(2,0)= sqrt(qx2)*sin(phi_k)
	       A1 = au(1)
	       Sigm0 = au(2)*2.568
             LAM = au(3)
	       X01 = au(4)
             ALPHAS = au(5)
	       if(first) then
	         write(6,*) ' sminfn: saturation selected ',saturation
	         write(6,*) ' sminfn: GBW: xgx0 = 3/4./PI^2/ALPHAS*SIGM0*R02*SCALE*EXP(-R02*SCALE) '
               write(6,*) ' sminfn: sigm0 = ',sigm0, ' alphas = ',alphas
               write(6,*) ' sminfn; r02 = (X0/X01)**LAM; with x01 = ',x01,' lam = ',lam
               write(6,*) ' sminfn: (1-x)**A6, A6 = ',AU(6)
	         first=.false.
	       endif

             xmymin=max(1e-7,xmin)  
              
             x0 = xmymin*(xmax/xmymin)**SMrgen(4)
             Wx0 = x0*log(xmax/xmymin)
             R02 = (X0/X01)**LAM
   	       Scale=P(1,0)**2+P(2,0)**2
             glu = 3.*SIGM0*R02*SCALE*EXP(-R02*SCALE)
             xgx0 = glu/4./9.8696/ALPHAS
             Wt0 = xgx0/x0*Wx0*WQG2
	       Wt0 = Wt0*(1-x0)**AU(6)
             Wt = Wt0
          else    
             xmymin=max(1e-7,xmin)   
             x0 = xmymin*(xmax/xmymin)**SMrgen(2)
             Wx0 = x0*log(xmax/xmymin)
	       A1 = au(1)
	       A2 = au(2)
             A3 = au(3)
	       A4 = au(4)
             A5 = au(5)
             A6 = au(6)
	       if(first) then
	         write(6,*) ' sminfn: initial paramterisation selected '
	         write(6,*) ' sminfn: A1*5.*(1./x0**A2)*(1.-x0)**A3*(1.-A4*x0+A5*sqrt(x0)+A6*x0**2)/x0'
               write(6,*) ' sminfn: A1 = ',A1,' A2 = ',A2,' A3 = ',A3
               write(6,*) ' sminfn: A4 = ',A4,' A5 = ',A5,' A6 = ',A6
	         first=.false.
             endif 
             Wt0 =A1*5.*(1./x0**A2)*(1.-x0)**A3*(1.-A4*x0+A5*sqrt(x0)+A6*x0**2)/x0 * Wx0
	       Wt = Wt0
          endif
        endif
	  Scale=P(1,0)**2+P(2,0)**2

	  If(iparton.eq.0) then
	    Kid(0) = 21
          Wtest = Wtest + Wt*x0
          ininorm(0) = Xnor*Wtest/Jev
          ininorm(3) = Xnor*Wtest/Jev
	  else
	    Kid(0) = iparton
          if(ipartonO.ne.iparton) first1=.true.
   10     continue
          x0=xmin**SMrgen(3)

c here do the starting distribution for the valence quarks
          PARM(1) = 'DEFAULT' 
          VAL(1) = Ipdf 
	    If(first1) then
              ipartonO=iparton
              xgmax = 0.
              CALL PDFSET(PARM,VAL)
c calculate the integral over xgx	

              QQ=Qs
	        QQ2=QQ*QQ
	        xnormn = 0.
     	        nx=100
	        xmi=0.0001
	        xma=0.95
	        dlxmin=log10(xmi)
	        dlxmax=log10(xma)
	        dx = (dlxmax-dlxmin)/real(nx)
              do i=0,nx
	          xt = 10**(dlxmin+dx*real(i))
                XX=DBLE(Xt)
                CALL STRUCTM(XX,QQ,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU)
c integrate quarks
                if(iparton.eq.1) then 
                  sum = DNV
                  elseif(iparton.eq.2) then
                  sum = UPV
                  else
                  write(6,*) ' sminfn: no valid iparton specified',iparton
                  write(6,*) 'sminfn: PROGRAM STOPPED '
                  stop
                endif
                if(sum.eq.sum) then  
	            if(i.lt.nx) then
	              deltax =10**(dlxmin+dx*real(i+1))-10**(dlxmin+dx*real(i))
                    xnormn = xnormn + real(sum)*deltax
	            endif
c	            write(6,*) ' deltax,glu ',deltax,glu,QQ2,PP2
                    test=sum*1.5
c                    write(6,*) 'xx, sum ',xx,sum
                    if(test.gt.xgmax) xgmax = test
	          endif 
              enddo
              write(6,*) '  sminfn Xnorm  new :',xnormn
		  Xnor =  xnormn  ! really respect mom-sum rule for valence quarks 
              ininorm(iparton)=Xnor
c              write(6,*) '  sminfn Xnorm new :',xnormn
	        first1 = .false.
	    endif  
          QQ=Qs
	    QQ2=QQ*QQ
	    
	    xx=x0	  

          CALL STRUCTM(XX,QQ,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU)
          if(iparton.eq.1) then 
              sum = DNV
              elseif(iparton.eq.2) then
              sum = UPV
              else
              write(6,*) ' sminfn: no valid iparton specified'
     &              ,iparton
              write(6,*) 'sminfn: PROGRAM STOPPED '
              stop
          endif
	    if(sum.ne.sum) goto 10  

  	    test = sum/xgmax
	    IF(test.ge.1) 
     &      write(6,*) ' sminfn: test > 1 ',test,xx,qq,sum,xgmax,iparton
c wt = f(x)/g(x) with f(x) = q(x) and g(x) = 1/x
c    = xq(x)  	   
c log1/xmin) not applied, since only constant for fixed xmin
          If (test.lt.SMrgen(4)) go to 10
          
	  Endif
	Endif  
c--compute xgbar
      xg=x0
      xgbar=-(P(1,0)**2+P(2,0)**2+p2(5)**2*x0*(2.-x0))
     +        /(Sbig*(1.-x0))
	xgbar =0
      P(3,0)=x0*p2(3)+xgbar*p1(3)
      P(4,0)=x0*p2(4)+xgbar*p1(4)
      Call SMumas(P(1,0))
c--proton spectator
      Call SMvdif(4,p2,P(1,0),pspec)
ctest............	
	yphton = 1
	yphbar = 0.
	Wini = 1.
cend.......... test.........	
	
      q1(3)=yphton*p1(3)+yphbar*p2(3)
      q1(4)=yphton*p1(4)+yphbar*p2(4)
c--electron spectator
      Call SMvdif(4,p1,q1,espec)
      q1(5)=-Qval
      P(6,0)=Wt
      P(7,0)=0.
      P(8,0)=0.
c	write(6,*) ' sminfn_gluon :, x0 = ',x0
      Return
      End
