
      Subroutine SMqtem(Tlike)
C--Finds Qtem
      Include 'SMallx.inc'
      Double Precision U0,Ul,R,D,C
      Integer n
	
	
      Real sudint,suda,fl,fu,eps
      Double Precision q2hi,q2lo,qs0,Ca,nf,Lambda
      Common/sudvar/q2hi,q2lo,qs0,Ca,nf,Lambda
	External suda,fl,fu
C Parameters for Sudakov form factors
C (NMXSUD= max no of entries in lookup table)
	Real ACCUR,QEV,SUD
	Integer INTER,NQEV,NSUD
	Integer NMXSUD
      PARAMETER (NMXSUD=1024)
      COMMON/SMUSUD/ACCUR,QEV(NMXSUD,6),SUD(NMXSUD,6),INTER,NQEV,NSUD
	Real Fdiv(NMXSUD),Adiv(NMXSUD)
      Integer Isud
	Common/SMSUD1/Isud
	Double Precision Qtemgg,Ttemgg,Qtemqq,Ttemqq,Qtemqg,Ttemqg,Qtemgq,Ttemgq 
	Common/SMSUD2/ Qtemgg,Ttemgg,Qtemqq,Ttemqq,Qtemqg,Ttemqg,Qtemgq,Ttemgq 
      Logical pdflib,quark,gluon,photon,saturation
      Common /SMbran2/pdflib,quark,gluon,photon,saturation
	Real sudlo,sudup
	Double Precision power,qfac,qnow
	Real Qtest,Stest
	Real Qlim,Sudmin(4),Sudmax(4)
	 
	Real DIVDIF
	External DIVDIF
	 
	Integer IQ,ISS,I,L,L1,L2,LL
	Logical First
      Common /SMstart/ First
	Integer Iseed,minuts
	Double Precision SMrgen
	External minuts
	Common/random/Iseed
	Double Precision ana,t0,t,tmin
	Integer Ismax
	 
CCC	 
      Logical Tlike
      Data Eps/1.E-5/
      If(Tlike) then
	write(6,*) ' this version of smqtem is not valid for tlike '
	stop
      endif
c HERWIG like parameter setting	 
      NQEV=1024
      NSUD = 0
      INTER=3
      ACCUR=1.D-6
      qlim = sqrt(Sbig)
c 	 
      nf=4. 
      Lambda=QCDlam
      Ca=3.
      eps = ACCUR
	 
      Qs0 = Qg
      Ismax = 4
	 
      IF(first) Then
c	  write(6,*) ' integrate Sudakov and produce lookup table'
         POWER=1./Real(NQEV-1)
         q2lo=Qs0**2
         QFAC=(1.1*qlim/sqrt(q2lo))**POWER
C--IS=1 FOR GLUON->GLUON+GLUON FORM FACTOR
C--IS=2 FOR quark->gluon+quark FORM FACTOR
C--IS=3 FOR gluon->quark+antiquark FORM FACTOR
C--IS=4 FOR quark->quark+GLUON FORM FACTOR
         DO 11 Is = 1,Ismax
	      ISS=IS
            SUD(1,IS)=0.
            QEV(1,IS)=q2lo
	      Sudmin(is)=99999999.
	      Sudmax(is)=-9999999.
	      Isud = Is
            DO 10 IQ=2,NQEV
               QNOW=QFAC*sqrt(QEV(IQ-1,IS))
	       if(qnow.ge.qmax) then
c	         write(6,*) ' smqtem qnow > qmax ',qnow,qmax
	       endif
	         q2hi = Qnow**2
     	         call gadap2(0.,1.,fl,fu,suda,eps,sudint)
               SUD(IQ,IS)=sudint
	         if(sudint.lt.sudmin(is)) sudmin(is)=sudint
	         if(sudint.gt.sudmax(is)) sudmax(is)=sudint
c               write(6,*) ' smqtem IQ,IS ',IQ,IS,q2hi
   10       QEV(IQ,IS)=q2hi
        write(6,*) ' new Sudakov ala Gavin '
        write(6,201) IS,NQEV
  201   FORMAT(1H1//10X,'EXTRACT FROM TABLE OF SUDAKOV FORM FACTOR NO.',
     &  I2,' (',I5,' ACTUAL ENTRIES)'//10X,'SUD IS PROBABILITY THAT',
     &  ' PARTON WITH GIVEN UPPER LIMIT ON Q WILL REACH THRESHOLD',
     &  ' WITHOUT BRANCHING'///2X,8('      Q     SUD ')/)
             L2=NQEV/8
             L1=L2/32
             IF (L1.LT.1) L1=1
             DO 40 L=L1,L2,L1
                LL=L+7*L2
                WRITE(6,30) (sqrt(QEV(I,IS)),exp(-SUD(I,IS)),I=L,LL,L2)
   30           FORMAT(2X,8(F9.2,F7.4))
   40        CONTINUE
   50         FORMAT(1H1)
	 
   11    Continue	 
	 first=.false.
      endif
 
      q2lo = QCDlam*exp(Told)
      q2lo = q2lo**2
      Qtest=q2lo
      R=SMrgen(1)
      Do Is=1,Ismax
         Qtest=q2lo
c here we ask sud(qtest)         
         sudlo=DIVDIF(SUD(1,IS),QEV(1,IS),NQEV,Qtest,INTER)	 
         If (R.eq.0.) R=Eps
            D=-Log(R)	 
	      stest = D + sudlo
            if(stest.gt.Sudmax(is)) then
c	  write(6,*) ' smqtem : stest,sudmin',stest,sudmin(is),sudmax(is)
	         stest=min(stest,sudmax(is))
	      endif 
            if(stest.lt.Sudmin(is)) then
c	  write(6,*) ' smqtem : stest,sudmin',stest,sudmin(is),sudmax(is)
	         stest=max(stest,sudmin(is))
	    endif 

	    if(sudlo.gt.stest) then
	       write(6,*) ' sudlo ',sudlo,stest,sudmin(is),sudmax(is)
	    endif
c here we ask QEV(sud)	
          Qtest = DIVDIF(QEV(1,IS),SUD(1,IS),NQEV,stest,INTER)
          
c          write(6,*) ' smqtem Qtest ',IS,sqrt(Qtest),R
	
          Qtem=sqrt(Max(0.,Qtest))
	    Qtem=Max(Qg,Qtem)
          Ttem = log(Qtem/QCDLam)

	    if(Ttem.lt.Told) then
	       write(6,*) ' smqtem_new problem: Ttem < Told ',Ttem,Told,Is
	       write(6,*) ' smqtem_new problem: Qtem < Qold ',Qtem,q2lo,Is
	    Endif
c          write(6,*) ' smqtem ',qtem,is
          If(IS.eq.1) then
             Qtem = sqrt(Max(0.,Qtest))
	       Qtem = Max(Qg,Qtem)
             Ttem = log(Qtem/QCDLam)
	
	       if(qtem.eq.0.) then
	          write(6,*) ' smqtem problem Qtem:',Qtem,Qtest,stest,D,
     &	     sudlo,q2lo,R,sudmin(is),sudmax(is)
                 Qtem=Qg+Eps
                 Ttem = log(Qtem/QCDLam)
	       endif
	       if(qtem.le.Qg) then
	          write(6,*) ' smqtem problem Qtem:',Qtem,Qg
                 Qtem=Qg+Eps
                 Ttem = log(Qtem/QCDLam)
	       endif
 
	       if(Qtem.ne.Qtem) then 
	          write(6,*) ' smqtem problem Qtem:',Qtem,Qtest,stest,
     &          D,sudlo,q2lo
	       endif
	       Qtemgg = Qtem
             Ttemgg = Ttem
          Elseif(IS.eq.2) then
             Qtemgq = sqrt(Max(0.,Qtest))
	       Qtemgq = Max(Qg,Qtemgq)
             Ttemgq = log(Qtemgq/QCDLam)
	
	       if(qtemgq.eq.0.) then
	           write(6,*) ' smqtem problem Qtem:',Qtemgq,Qtest,stest,D,
     &	           sudlo,q2lo,R,sudmin(is),sudmax(is)
                 Qtemgq=Qg+Eps
                 Ttemgq = log(Qtemgq/QCDLam)
	       endif
	       if(qtemgq.le.Qg) then
	           write(6,*) ' smqtem problem Qtem:',Qtem,Qg
                 Qtemgq=Qg+Eps
                 Ttemgq = log(Qtemgq/QCDLam)
	       endif
          Elseif(IS.eq.3) then
             Qtemqq=sqrt(Max(0.,Qtest))
	       Qtemqq=Max(Qg,Qtemqq)
             Ttemqq = log(Qtemqq/QCDLam)
	
	       if(qtemqq.eq.0.) then
	          write(6,*) ' smqtem problem Qtem:',Qtemqq,Qtest,stest,D,
     &	          sudlo,q2lo,R,sudmin(is),sudmax(is)
                Qtemqq=Qg+Eps
                Ttemqq = log(Qtemqq/QCDLam)
	       endif
	       if(qtemqq.le.Qg) then
	            write(6,*) ' smqtem problem Qtem:',Qtem,Qg
                  Qtemqq=Qg+Eps
                  Ttemqq = log(Qtemqq/QCDLam)
	       endif
          Elseif(IS.eq.4) then
             Qtemqg=sqrt(Max(0.,Qtest))
	       Qtemqg=Max(Qg,Qtemqg)
             Ttemqg = log(Qtemqg/QCDLam)
         	
	       if(qtemqg.eq.0.) then
	          write(6,*) ' smqtem problem Qtem:',Qtemqg,Qtest,stest,D,
     &	          sudlo,q2lo,R,sudmin(is),sudmax(is)
                Qtemqg=Qg+Eps
                Ttemqg = log(Qtemqg/QCDLam)
	       endif
	       if(qtemqg.le.Qg) then
	          write(6,*) ' smqtem problem Qtem:',Qtem,Qg
                Qtemqg=Qg+Eps
                Ttemqg = log(Qtemqg/QCDLam)
	       endif
	    endif
	Enddo
      End
