      function g1p(y)
	
	Implicit None
	Real g1p,y
	Double Precision g1t,z1,z1min,z1max
	Double Precision zmax,asb
	Double Precision Qtem,Capb,QCDlam
	Common/g1int/Qtem,Capb,QCDlam,zmax
	Integer Ipgg,ns_sel
	Double Precision scal 
	common/Pggsel/Ipgg,ns_sel,scal

	Double Precision splitt,asbmy
	External splitt,asbmy
	Double Precision Cf,Ca
	Ca = 3d0
	Cf = 4d0/3d0
c z1= 1-z	
c z1min= = Q0/q, z1max=1
       z1min=1.-zmax
	 z1max=1.
	 z1= z1min*(z1max/z1min)**y
       g1t = asbmy(scal*qtem*z1) *Splitt(z1)	 
	 g1t=g1t*z1*log(z1max/z1min)
	 g1p=g1t
	 return
	 end
	 
      function g0p(y)
	
	Implicit None
	Real g0p,y
	Double Precision g0t,z1,z1min,z1max,asbold
	Double Precision Qtem,QQt,xmin,zmax,Qg
	Common/g0int/Qtem,QQt,xmin,asbold,zmax,Qg
	Integer Ipgg,ns_sel
	Double Precision scal 
	common/Pggsel/Ipgg,ns_sel,scal

	Double Precision Splitt0,Nonsud,asbmy
	External Splitt0,Nonsud,asbmy
	Double Precision as
	Double Precision Cf,Ca
	Ca = 3d0
	Cf = 4d0/3d0
      z1min=xmin
	
	
	
	z1max=zmax
	z1= z1min*(z1max/z1min)**y
	as=asbmy(scal*QQt)
      if(Ipgg.ge.2) then
	as= asbmy(scal*Qtem)
	else
	as=asbmy(scal*QQt)
	endif
      g0t = as *Splitt0(z1)*Nonsud(z1)	
	g0t=g0t*z1*log(z1max/z1min)
	g0p=g0t
	
	return
	end
	Function Splitt(z1)
	Implicit None
	Integer Ipgg,ns_sel
	Double Precision scal
	common/Pggsel/Ipgg,ns_sel,scal

	Double Precision Splitt,z1
	Double Precision BB
	Common /splitting/ BB
	If(Ipgg.eq.0.or.Ipgg.eq.2) then
c first the simple 1/(1-z)=1/z1	 
	  Splitt=1./z1
	  else
c now gavins version
       Splitt = ((1.-z1)/z1 +BB*(1.-z1)*z1)
	endif
	Return
	End 
	 
	
      Function Splitt0(z)
	Implicit None
	Integer Ipgg,ns_sel
	Double Precision scal
	common/Pggsel/Ipgg,ns_sel,scal
	Double Precision Splitt0,z,z1
	Double Precision BB
	Common /splitting/ BB
	z1 = z
c first the simple 1/z	 
	If(Ipgg.eq.0.or.Ipgg.eq.2) then
         Splitt0=1./z1
	   else
c now gavins version
         Splitt0 = (1.-z1)/z1 + (1.-BB)*z1*(1.-z1)
	 endif
	 Return
	 End 
	 
      Function Nonsud(zz)
	Implicit None
      Logical       onel,tevol,hspot,powin,afix
      Common/SMlcom/onel,tevol,hspot,powin,afix
	
	Double Precision Nonsud,z,zz
	Double Precision Nonsud1,z1,ktqt,asbold,z0,z0c,z01
	Double PRecision Nonsud2
	Double Precision BB
	Common /splitting/ BB
	Double Precision Qtem,QQt,xmin,zmax,Qg
	Common/g0int/Qtem,QQt,xmin,asbold,zmax,Qg
	Double Precision Qtemp,Capbp,QCDlamp,zmax1
	Common/g1int/Qtemp,Capbp,QCDlamp,zmax1
	Double Precision Q0	
	Double Precision term1,term2,term3,term4,term5,term6,term7
	Double Precision t0,B,k,q
	Double Precision tq,tk,tc,zc,zt
	Integer ncall
	Integer Ipgg,ns_sel
	Double Precision scal 
	common/Pggsel/Ipgg,ns_sel,scal
	Double Precision t1,t2,t3,t4,t5,t6,t7,t8,t9,t10
	Double Precision t11,t12,t13,t14,t15,t16,t17,t18,t19
	Double Precision t20,t21,t22,t23,t24,t25,t26,t27,t28,t29
	Double Precision t30,t31,t32,t33,t34,t35,t36,t37,t38,t39
	Double Precision t40,t42,t41,t43,t45,t46,t47,t48
	Double Precision t50,t51,t52,t53,t55,t56,t58,t59
	Double Precision t62,t63,t65,t66,t68
	Double Precision t70,t71,t74,t75,t76
	Double Precision t80,t82,t85,t92,t94,t95
	Double Precision t102,t107,t108
	Double Precision a0,b0,c0,d0
	Double Precision one
	Double Precision Ei
	External Ei

c ns_sel = -1: standard non sudakov old
c ns_sel = 0: standard non sudakov with cut
c ns_sel = 1: full splitting
c ns_sel = 2: alphas(q) sing. terms
c ns_sel = 3: alphas(q) full splitting
      Integer Insq
c     Insq = 0 non-sudakov with alphasq with hannes treatment
c	Insq = 1 non-sudakov with alphasq with gavin treatment
      Data insq/0/
	data ncall/0/
	Double Precision asbmy
	External asbmy
	Logical first
	Data first/.true./
	if(first) then 
	   write(6,*) ' non-sudakov selection : ns_sel = ',ns_sel
	   write(6,*) ' Insq = ',Insq
	   first=.false.
	endif
	if(onel) then
	  Nonsud = 1.
	  else 
	
	z1=zz
	ktqt=QQt/Qtem
	if(ktqt.ge.1.) then
	  z0= 1.
	Elseif(z1.lt.ktqt.and.ktqt.le.1.) then
	  z0=ktqt
	elseif(ktqt.le.z1) then
	  z0=z1
	else
	  write(6,*) ' Nonsud : this should never happen QQt,Qtem:',QQt,Qtem
	Endif
	if(z1.gt.z0) then
	   write(6,*) ' Nonsud z1,z0',z1,z0,qtem,qqt
	endif
      k=QQt
      q=Qtem
      Q0=Qg  
      Q0=0.2
      z=z1
      tk = log(k**2/QCDlamp**2)
	tq = log(q**2/QCDlamp**2)
	tc = log(Q0**2/QCDlamp**2)
	zc = Q0/q
	zt = max(z1,zc)
c now gavins version
	B=BB
	if(ns_sel.eq.-1) then
         Nonsud1 =  log(z0/z1)*log(k**2/z0/z1/q**2)
         Nonsud1 =  -asbmy(scal*k)*Nonsud1
	elseif(ns_sel.eq.0) then
c the simple non - sudakov
	   if(tk.lt.tc) then
	     Nonsud1 = 0.
	   else
           Nonsud1 =  log(z0/zt)*log(k**2/z0/zt/q**2)
	   if(zc.gt.z1) then      
              Nonsud1 = Nonsud1+(log(zc/z1))*log(k**2/Q0**2)
	   endif
         Nonsud1 =  -asbmy(scal*k)*Nonsud1
	   endif  
	
	elseif(ns_sel.eq.1) then
	   if(tk.lt.tc) then
	     t0 = 0.
	   else           
c
c
c here comes the new part
           t0 = -log(k/z0/q)**2+log(k/z0/q)*z0**2+z0**2/2-
     #          B*log(k/z0/q)*z0**2-
     #          z0**2*B/2-2*z0*log(k/z0/q)-
     #          2*z0-2.D0/3.D0*z0**3*log(k/z0/q)-2.D0/9.D0*z0**3+
     #          2.D0/3.D0*B*z0**3*log(k/z0/q)+2.D0/9.D0*z0**3*B+
     #          log(k/zt/q)**2-log(k/zt/q)*zt**2-
     #          zt**2/2+B*log(k/zt/q)*zt**2+zt**2*B/2+2*zt*log(k/zt/q)+
     #          2*zt+2.D0/3.D0*zt**3*log(k/zt/q)+2.D0/9.D0*zt**3-
     #          2.D0/3.D0*B*zt**3*log(k/zt/q)-2.D0/9.D0*zt**3*B
           
            If(Insq.eq.0) then
	        if(zc.gt.z1) then      
                t1 = -log(k/zc/q)**2+log(k/zc/q)*zc**2+zc**2/2-
     #          B*log(k/zc/q)*zc**2-
     #          zc**2*B/2-2*zc*log(k/zc/q)-
     #          2*zc-2.D0/3.D0*zc**3*log(k/zc/q)-2.D0/9.D0*zc**3+
     #          2.D0/3.D0*B*zc**3*log(k/zc/q)+2.D0/9.D0*zc**3*B+
     #          log(k/z1/q)**2-log(k/z1/q)*z1**2-
     #          z1**2/2+B*log(k/z1/q)*z1**2+z1**2*B/2+2*z1*log(k/z1/q)+
     #          2*z1+2.D0/3.D0*z1**3*log(k/z1/q)+2.D0/9.D0*z1**3-
     #          2.D0/3.D0*B*z1**3*log(k/z1/q)-2.D0/9.D0*z1**3*B
                t0 = t0 + t1
	        endif
     
 	      Elseif(Insq.eq.1) then
c now gavins version ( for full splitting fct )
	          if(zc.gt.z1) then      
                   t1 = 2*log(k/q0)*log(zc)-2*log(k/q0)*zc-
     #	       2.D0/3.D0*log(k/q0)*zc**3+
     #             log(k/q0)*zc**2+2.D0/3.D0*log(k/q0)*B*zc**3-
     #             log(k/q0)*B*zc**2-2*log(k/q0)*log(z1)+
     #             2*log(k/q0)*z1+2.D0/3.D0*log(k/q0)*z1**3-
     #             log(k/q0)*z1**2-2.D0/3.D0*log(k/q0)*B*z1**3+
     #             log(k/q0)*B*z1**2
                   t0 = t0 + t1
	          endif
	      endif
	   endif
         Nonsud1 =  -asbmy(scal*k)*t0
	elseif(ns_sel.eq.2) then
c the simple non - sudakov

c here non sudakov with alphas(q) 
	   if(tk.lt.tc) then
	      Nonsud1 = 0.
	   else
            Nonsud1 = 0.5*log(tk/(tq+2.*log(z0)))*tq+
     &          log(tk/(tq+2*log(z0)))*log(z0)+0.5*tq+log(z0) -
     &         (0.5*log(tk/(tq+2.*log(zt)))*tq+
     &          log(tk/(tq+2*log(zt)))*log(zt)+0.5*tq+log(zt))
            If(Insq.eq.0) then
               Nonsud1 =  Nonsud1 * Capbp 
	         if(zc.gt.z1) then      
   	            z01=zc
	            ktqt=QQt/Qtem
                  if(ktqt.ge.1.) then
	              z0c= 1.
	              z0c=z01
	            Elseif(z01.lt.ktqt.and.ktqt.le.1.) then
	              z0c=min(ktqt,z01)
	            elseif(ktqt.le.z01) then
	              z0c=z01
	            else
	              write(6,*) ' Nonsud : this should never happen '
	            Endif 
	            Nonsud1 = Nonsud1 + asbmy(q0)*
     &	       log(z0c/z1)*log(k**2/z0c/z1/q**2)
	         endif
 	      Elseif(Insq.eq.1) then
	         if(zc.gt.z1) then      
                 Nonsud1 = Nonsud1+(log(zc)-log(z1))*log(tk/tc)
	         endif
               Nonsud1 = Nonsud1 * Capbp  
	      endif
            if(Nonsud1.ne.Nonsud1) then
	        write(6,*) ' problem with new Non Sudakov '
	        write(6,*) ' z0,z1 ',z0,z1,k,q
	        write(6,*) ' log(tk/(tq+2*log(z0)))',
     #	     log(tk/(tq+2.*log(z0)))
	        write(6,*) ' log(tk/(tq+2*log(z1)))',
     #           log(tk/(tq+2.*log(z1)))
	        write(6,*) ' tq ',tq,' tk ',tk,log(z0),log(z1)
	        write(6,*) '  Non - Suadkov: ',Nonsud1
            endif
	   endif
         Nonsud1 = -Nonsud1  
	elseif(ns_sel.eq.3) then
c here non sudakov with fullspiltting and alphas(q) 
	   if(tk.lt.tc) then
	     t0 = 0.
	     Nonsud1 = 0.
	   else
           one = 1.d0
           t1 = log(tk)
           t3 = tq/2
           t4 = log(zt)
           t5 = t3+t4
           t6 = log(t5)
           t7 = zt**2
           t8 = t7*zt
           t9 = t6*t8
           t12 = t6*t7
           t14 = log(z0)
           t16 = 3./2.*tq
           t17 = exp(-t16)
           a0=-3*t4-t16
           t20 = Ei(one,a0)
           t24 = z0**2
           t25 = t24*z0
           t28 = 2*tq
           t31 = log(t28+4*t14)
	     b0=-3*t14-t16
           t36 = Ei(one,b0)
           t39 = exp(-t3)
           t40 = -t14-t3
           t41 = Ei(one,t40)
           t45 = log(-t40)
           t47 = exp(-tq)
	     c0=-2*t14-tq
           t50 = Ei(one,c0)
           t56 = t45*t25
           t58 = -z0*t1-t9/3-t6*zt-t4+t12/2+t1*t14+t14-t17*t20/3+
     #          t6*t4-t25*t1/3
     #          -tq*t31/2+t17*t36/3+t39*t41+t24*t1/2+t45*z0-t47*t50/2+
     #          zt*t1-t7*t1/2+t56/3
           t62 = log(t28+4*t4)
           t65 = t45*t24
           t70 = B*t17
           t80 = B*t47
	     d0=-2*t4-tq
           t92 = Ei(one,d0)
           t95 = Ei(one,-t5)
           t107 = -t1*t4+tq*t62/2-t65/2+t8*t1/3-t45*t14+t70*t20/3-
     #           t24*B*t1/2-
     #           t56*B/3-t12*B/2+t80*t50/2+t25*B*t1/3-t70*t36/3+t9*B/3+
     #           t47*t92/2-t39
     #           *t95+t7*B*t1/2+t65*B/2-t8*B*t1/3-t80*t92/2
           t108 = t58+t107

           t0 = t108
           Nonsud1 = -t0 * Capbp 
	     t0 = 0
           If(Insq.eq.0) then
	        if(zc.gt.z1) then      
   	           z01=zc
	           ktqt=QQt/Qtem
                 if(ktqt.ge.1.) then
	              z0c= 1.
	              z0c=z01
	           Elseif(z01.lt.ktqt.and.ktqt.le.1.) then
	              z0c=min(ktqt,z01)
	           elseif(ktqt.le.z01) then
	              z0c=z01
	           else
	             write(6,*) ' Nonsud : this should never happen '
	        Endif 
           
              t0 = -log(k/z0c/q)**2+log(k/z0c/q)*z0c**2+z0c**2/2-B*
     #	   log(k/z0c/q)*
     #         z0c**2-z0c**2*B/2-2*log(k/z0c/q)*z0c-2*z0c-2.D0/3.D0*
     #         z0c**3*log(k/z0c/q)
     #         -2.D0/9.D0*z0c**3+2.D0/3.D0*B*z0c**3*log(k/z0c/q)+
     #         2.D0/9.D0*z0c**3*B+log(k/z1/q)**2-log(k/z1/q)*z1**2-
     #         z1**2/2+B*log(k/z1/q)*z1**2+z1**2*B/2
     #         +2*log(k/z1/q)*z1+2*z1+2.D0/3.D0*z1**3*log(k/z1/q)+
     #         2.D0/9.D0*z1**3
     #         -2.D0/3.D0*B*z1**3*log(k/z1/q)-2.D0/9.D0*z1**3*B
              t0 = - asbmy(q0)* t0 
              if(t0.gt.0) write(6,*) 'exp(t0) > 0 ',t0
	        Nonsud1 = Nonsud1+ t0
              if(Nonsud1.gt.0) write(6,*) 'exp(Nonsud1) > 0 ',Nonsud1
		  endif
 	     Elseif(Insq.eq.1) then
	        if(zc.gt.z1) then      
                 t0 = 2*log(k/q0)*log(zc)-2*log(k/q0)*zc-
     #	     2.D0/3.D0*log(k/q0)*zc**3+
     #           log(k/q0)*zc**2+2.D0/3.D0*log(k/q0)*B*zc**3-
     #           log(k/q0)*B*zc**2-2*log(k/q0)*log(z1)+
     #           2*log(k/q0)*z1+2.D0/3.D0*log(k/q0)*z1**3-
     #           log(k/q0)*z1**2-2.D0/3.D0*log(k/q0)*B*z1**3+
     #           log(k/q0)*B*z1**2
                 t0=-asbmy(scal*k)*t0
                 Nonsud1 = Nonsud1 + t0 
		     
	        endif
	     Endif

           if(Nonsud1.ne.Nonsud1) then
	        write(6,*) ' problem with new Non Sudakov '
	        write(6,*) ' z0,z1 ',z0,z1,k,q
	        write(6,*) '  Non - Suadkov: ',Nonsud1,t0,t108
           endif
	   endif
	else 
	  write(6,*) '  Non - Suadkov: ',ns_sel,' not yet implemented '
        stop
      endif


      Nonsud1 = exp(Nonsud1)
     
     
	If(Nonsud1.lt.0.0.or.Nonsud1.gt.1.0001) Then
	  ncall=ncall+1
	  If(ncall.le.1000) then
	  write(6,*) ' Problem with new Non - Suadkov: ',Nonsud1,ns_sel
	  endif 
	  Nonsud1 = 1.
	Endif
      Nonsud = Nonsud1
	endif
	Return
	End 
      Function Ei(x1,x2)
	Implicit None
	Double Precision x1,x2,Dexpin,Ei
	Integer i
	External Dexpin
	if(x1.eq.1.) then
	  Ei=dexpin(x2)
	  else
	  write(6,*) ' Ei: i= ',x1,' not implemented '
	  Endif
	Return
	End 
      Function Nonsud0(z)
	Implicit None
      
      Logical       onel,tevol,hspot,powin,afix
      Common/SMlcom/onel,tevol,hspot,powin,afix
	Double Precision Nonsud0,z
	Double Precision Nonsud1,z1,ktqt,asbold,z0
	Double Precision BB
	Common /splitting/ BB
	Double Precision Qtem,QQt,xmin,zmax,Qg
	Common/g0int/Qtem,QQt,xmin,asbold,zmax,Qg
	if(onel) then 
	 Nonsud0 = 1.
	 else
	z1=z
	ktqt=QQt/Qtem

	if(ktqt.ge.1.) then
	  z0= 1.
	  Elseif(z1.lt.ktqt.and.ktqt.le.1.) then
	  z0=ktqt
	  elseif(ktqt.le.z1) then
	  z0=z1
	  else
	  write(6,*) ' Nonsud : this should never happen '
	  Endif
c the simple non - sudakov	 
	Nonsud1 =  -asbold*log(z0/z1)*log(QQt**2/z0/z1/Qtem**2) !hannes new 
      Nonsud1 = exp(Nonsud1)
	If(Nonsud1.lt.0.0.or.Nonsud1.gt.1.0) Then
	write(6,*) ' Problem with old Non - Suadkov: ',Nonsud1
	Endif
      Nonsud0 = Nonsud1
	endif
	 Return
	 End 
